Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_main.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_main.F90	(revision 5116)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_main.F90	(revision 5117)
@@ -114,59 +114,59 @@
     !   arguments:
     !   ----------
-    integer, intent(in) :: itap, ngrid, nlay
-    real, intent(in) :: ptimestep
-    real, intent(in), dimension(ngrid, nlay) :: ptemp, puwind, pvwind, pplay, pphi, ptemp_env, po_env
+    INTEGER, INTENT(IN) :: itap, ngrid, nlay
+    REAL, INTENT(IN) :: ptimestep
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay) :: ptemp, puwind, pvwind, pplay, pphi, ptemp_env, po_env
     ! ATTENTION : zpspsk est inout et out mais c'est pas forcement pour de bonnes raisons (FH, 2023)
-    real, intent(in), dimension(ngrid, nlay) :: p_o
-    real, intent(out), dimension(ngrid, nlay) :: zpspsk
-    real, intent(in), dimension(ngrid, nlay + 1) :: pplev
-    integer, intent(out), dimension(ngrid) :: lmax
-    real, intent(out), dimension(ngrid, nlay) :: pdtadj, pduadj, pdvadj, pdoadj, entr0, detr0
-    real, intent(out), dimension(ngrid, nlay) :: ztla, zqla, zqta, zqsatth, zthl
-    real, intent(out), dimension(ngrid, nlay + 1) :: fm0, zw2, fraca
-    real, intent(inout), dimension(ngrid) :: zmax0, f0
-    real, intent(out), dimension(ngrid, nlay) :: ztva, ztv
-    logical, intent(in) :: debut
-    real, intent(out), dimension(ngrid, nlay) :: ratqscth, ratqsdiff
-
-    real, intent(out), dimension(ngrid) :: pcon
-    real, intent(out), dimension(ngrid, nlay) :: rhobarz, wth3
-    real, intent(out), dimension(ngrid) :: wmax_sec
-    integer, intent(out), dimension(ngrid) :: lalim
-    real, intent(out), dimension(ngrid, nlay + 1) :: fm
-    real, intent(out), dimension(ngrid, nlay) :: alim_star
-    real, intent(out), dimension(ngrid) :: zmax, zcong
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay) :: p_o
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: zpspsk
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay + 1) :: pplev
+    INTEGER, INTENT(OUT), DIMENSION(ngrid) :: lmax
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: pdtadj, pduadj, pdvadj, pdoadj, entr0, detr0
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: ztla, zqla, zqta, zqsatth, zthl
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay + 1) :: fm0, zw2, fraca
+    REAL, INTENT(INOUT), DIMENSION(ngrid) :: zmax0, f0
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: ztva, ztv
+    logical, INTENT(IN) :: debut
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: ratqscth, ratqsdiff
+
+    REAL, INTENT(OUT), DIMENSION(ngrid) :: pcon
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: rhobarz, wth3
+    REAL, INTENT(OUT), DIMENSION(ngrid) :: wmax_sec
+    INTEGER, INTENT(OUT), DIMENSION(ngrid) :: lalim
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay + 1) :: fm
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: alim_star
+    REAL, INTENT(OUT), DIMENSION(ngrid) :: zmax, zcong
 
     !   local:
     !   ------
 
-    integer, save :: igout = 1
+    INTEGER, save :: igout = 1
     !$OMP THREADPRIVATE(igout)
-    integer, save :: lunout1 = 6
+    INTEGER, save :: lunout1 = 6
     !$OMP THREADPRIVATE(lunout1)
-    integer, save :: lev_out = 10
+    INTEGER, save :: lev_out = 10
     !$OMP THREADPRIVATE(lev_out)
 
-    real lambda, zf, zf2, var, vardiff, CHI
-    integer ig, k, l, ierr, ll
-    logical sorties
-    real, dimension(ngrid) :: linter, zmix, zmax_sec, lintercong
-    integer, dimension(ngrid) :: lmin, lmix, lmix_bis, nivcon, lcong
-    real, dimension(ngrid, nlay) :: ztva_est
-    real, dimension(ngrid, nlay) :: deltaz, zlay, zdthladj, zu, zv, z_o, zl, zva, zua, z_oa
-    real, dimension(ngrid, nlay) :: ztemp_env ! temperarure liquide de l'environnement
-    real, dimension(ngrid, nlay) :: zta, zha, q2, wq, wthl, wthv, thetath2, wth2
-    real, dimension(ngrid, nlay) :: rho, masse
-    real, dimension(ngrid, nlay + 1) :: zw_est, zlev
-    real, dimension(ngrid) :: wmax, wmax_tmp
-    real, dimension(ngrid, nlay + 1) :: f_star
-    real, dimension(ngrid, nlay) :: entr, detr, entr_star, detr_star, alim_star_clos
-    real, dimension(ngrid, nlay) :: zqsat, csc
-    real, dimension(ngrid) :: zcon, zcon2, alim_star_tot, f
-    real, dimension(ngrid, nlay) :: entrdn, detrdn
-    logical, dimension(ngrid, nlay) :: mask
-
-    character (len = 20) :: modname = 'thermcell_main'
-    character (len = 80) :: abort_message
+    REAL lambda, zf, zf2, var, vardiff, CHI
+    INTEGER ig, k, l, ierr, ll
+    LOGICAL sorties
+    REAL, DIMENSION(ngrid) :: linter, zmix, zmax_sec, lintercong
+    INTEGER, DIMENSION(ngrid) :: lmin, lmix, lmix_bis, nivcon, lcong
+    REAL, DIMENSION(ngrid, nlay) :: ztva_est
+    REAL, DIMENSION(ngrid, nlay) :: deltaz, zlay, zdthladj, zu, zv, z_o, zl, zva, zua, z_oa
+    REAL, DIMENSION(ngrid, nlay) :: ztemp_env ! temperarure liquide de l'environnement
+    REAL, DIMENSION(ngrid, nlay) :: zta, zha, q2, wq, wthl, wthv, thetath2, wth2
+    REAL, DIMENSION(ngrid, nlay) :: rho, masse
+    REAL, DIMENSION(ngrid, nlay + 1) :: zw_est, zlev
+    REAL, DIMENSION(ngrid) :: wmax, wmax_tmp
+    REAL, DIMENSION(ngrid, nlay + 1) :: f_star
+    REAL, DIMENSION(ngrid, nlay) :: entr, detr, entr_star, detr_star, alim_star_clos
+    REAL, DIMENSION(ngrid, nlay) :: zqsat, csc
+    REAL, DIMENSION(ngrid) :: zcon, zcon2, alim_star_tot, f
+    REAL, DIMENSION(ngrid, nlay) :: entrdn, detrdn
+    logical, DIMENSION(ngrid, nlay) :: mask
+
+    CHARACTER (LEN = 20) :: modname = 'thermcell_main'
+    CHARACTER (LEN = 80) :: abort_message
 
 
@@ -177,5 +177,5 @@
       REAL xtpo_tmp(ngrid,nlay)
       REAL xtzo_tmp(ngrid,nlay)
-      integer ixt
+      INTEGER ixt
 #endif
 
@@ -186,5 +186,5 @@
     fm = 0. ; entr = 0. ; detr = 0.
 
-    if (prt_level>=1) PRINT*, 'thermcell_main V4'
+    IF (prt_level>=1) PRINT*, 'thermcell_main V4'
 
     sorties = .TRUE.
@@ -204,5 +204,5 @@
     enddo
 
-    if (prt_level>=20) THEN
+    IF (prt_level>=20) THEN
       do ig = 1, ngrid
         PRINT*, 'th_main ig f0', ig, f0(ig)
@@ -223,5 +223,5 @@
     ! avec le theta_v effectif de l'environnement.
 
-    if (iflag_thermals_tenv - 10 * (iflag_thermals_tenv / 10) == 0) THEN
+    IF (iflag_thermals_tenv - 10 * (iflag_thermals_tenv / 10) == 0) THEN
       CALL thermcell_env(ngrid, nlay, p_o, ptemp_env, puwind, pvwind, pplay, &
               pplev, z_o, ztemp_env, zl, ztv, zthl, zu, zv, zpspsk, zqsat, lcong, lintercong, lev_out)
@@ -274,5 +274,5 @@
     endif
 
-    if (prt_level>=1) PRINT*, 'thermcell_main apres thermcell_env'
+    IF (prt_level>=1) PRINT*, 'thermcell_main apres thermcell_env'
 
     !------------------------------------------------------------------------
@@ -314,5 +314,5 @@
 
     rho(:, :) = pplay(:, :) / (zpspsk(:, :) * RD * ztv(:, :))
-    if (prt_level>=10) WRITE(lunout, *) 'WARNING thermcell_main rhobarz(:,1)=rho(:,1)'
+    IF (prt_level>=10) WRITE(lunout, *) 'WARNING thermcell_main rhobarz(:,1)=rho(:,1)'
     rhobarz(:, 1) = rho(:, 1)
     do l = 2, nlay
@@ -322,5 +322,5 @@
       masse(:, l) = (pplev(:, l) - pplev(:, l + 1)) / RG
     enddo
-    if (prt_level>=1) PRINT*, 'thermcell_main apres initialisation'
+    IF (prt_level>=1) PRINT*, 'thermcell_main apres initialisation'
 
     !------------------------------------------------------------------
@@ -395,5 +395,5 @@
     !--------------------------------------------------------------------------------
 
-    if (prt_level>=1) PRINT*, 'avant thermcell_plume ', lev_out
+    IF (prt_level>=1) PRINT*, 'avant thermcell_plume ', lev_out
 
     !=====================================================================
@@ -411,5 +411,5 @@
     !=====================================================================
 
-    if (iflag_thermals_ed<=9) THEN
+    IF (iflag_thermals_ed<=9) THEN
       !         PRINT*,'THERM NOUVELLE/NOUVELLE Arnaud'
       CALL thermcell_plume_6A(itap, ngrid, nlay, ptimestep, ztv, zthl, p_o, zl, rhobarz, &
@@ -434,11 +434,11 @@
     endif
 
-    if (prt_level>=1) PRINT*, 'apres thermcell_plume ', lev_out
+    IF (prt_level>=1) PRINT*, 'apres thermcell_plume ', lev_out
 
     CALL test_ltherm(ngrid, nlay, pplay, lalim, ztv, p_o, ztva, zqla, f_star, zw2, 'thermcell_plum lalim ')
     CALL test_ltherm(ngrid, nlay, pplay, lmix, ztv, p_o, ztva, zqla, f_star, zw2, 'thermcell_plum lmix  ')
 
-    if (prt_level>=1) PRINT*, 'thermcell_main apres thermcell_plume'
-    if (prt_level>=10) THEN
+    IF (prt_level>=1) PRINT*, 'thermcell_main apres thermcell_plume'
+    IF (prt_level>=10) THEN
       WRITE(lunout1, *) 'Dans thermcell_main 2'
       WRITE(lunout1, *) 'lmin ', lmin(igout)
@@ -468,5 +468,5 @@
     CALL test_ltherm(ngrid, nlay, pplay, lmax, ztv, p_o, ztva, zqla, f_star, zw2, 'thermcell_heig lmax  ')
 
-    if (prt_level>=1) PRINT*, 'thermcell_main apres thermcell_height'
+    IF (prt_level>=1) PRINT*, 'thermcell_main apres thermcell_height'
 
     !-------------------------------------------------------------------------------
@@ -480,6 +480,6 @@
     CALL test_ltherm(ngrid, nlay, pplay, lalim, ztv, p_o, ztva, zqla, f_star, zw2, 'thermcell_dry  lalim ')
 
-    if (prt_level>=1) PRINT*, 'thermcell_main apres thermcell_dry'
-    if (prt_level>=10) THEN
+    IF (prt_level>=1) PRINT*, 'thermcell_main apres thermcell_dry'
+    IF (prt_level>=10) THEN
       WRITE(lunout1, *) 'Dans thermcell_main 1b'
       WRITE(lunout1, *) 'lmin ', lmin(igout)
@@ -499,5 +499,5 @@
 
     !CR Appel de la fermeture seche
-    if (iflag_thermals_closure==1) THEN
+    IF (iflag_thermals_closure==1) THEN
       CALL thermcell_closure(ngrid, nlay, r_aspect_thermals, ptimestep, rho, &
               zlev, lalim, alim_star_clos, zmax_sec, wmax_sec, f)
@@ -506,5 +506,5 @@
       ! Appel avec les zmax et wmax tenant compte de la condensation
       ! Semble moins bien marcher
-    else if (iflag_thermals_closure==2) THEN
+    ELSE IF (iflag_thermals_closure==2) THEN
       CALL thermcell_closure(ngrid, nlay, r_aspect_thermals, ptimestep, rho, &
               zlev, lalim, alim_star, zmax, wmax, f)
@@ -516,5 +516,5 @@
     IF(prt_level>=1)PRINT*, 'thermcell_closure apres thermcell_closure'
 
-    if (tau_thermals>1.) THEN
+    IF (tau_thermals>1.) THEN
       lambda = exp(-ptimestep / tau_thermals)
       f0 = (1. - lambda) * f + lambda * f0
@@ -524,6 +524,6 @@
 
     ! Test valable seulement en 1D mais pas genant
-    if (.not. (f0(1)>=0.)) THEN
-      abort_message = '.not. (f0(1).ge.0.)'
+    IF (.NOT. (f0(1)>=0.)) THEN
+      abort_message = '.NOT. (f0(1).ge.0.)'
       CALL abort_physic (modname, abort_message, 1)
     endif
@@ -539,5 +539,5 @@
     !IM 060508    &       detr,zqla,zmax,lev_out,lunout,igout)
 
-    if (prt_level>=1) PRINT*, 'thermcell_main apres thermcell_flux'
+    IF (prt_level>=1) PRINT*, 'thermcell_main apres thermcell_flux'
     CALL test_ltherm(ngrid, nlay, pplay, lalim, ztv, p_o, ztva, zqla, f_star, zw2, 'thermcell_flux lalim ')
     CALL test_ltherm(ngrid, nlay, pplay, lmax, ztv, p_o, ztva, zqla, f_star, zw2, 'thermcell_flux lmax  ')
@@ -549,5 +549,5 @@
     !------------------------------------------------------------------
 
-    if (tau_thermals>1.) THEN
+    IF (tau_thermals>1.) THEN
       lambda = exp(-ptimestep / tau_thermals)
       fm0 = (1. - lambda) * fm + lambda * fm0
@@ -569,5 +569,5 @@
     do l = 2, nlay
       do ig = 1, ngrid
-        if (zw2(ig, l)>1.e-10) THEN
+        IF (zw2(ig, l)>1.e-10) THEN
           fraca(ig, l) = fm(ig, l) / (rhobarz(ig, l) * zw2(ig, l))
         else
@@ -581,5 +581,5 @@
     !------------------------------------------------------------------
     IF (iflag_thermals_down > 0) THEN
-      if (debut) PRINT*, 'WARNING !!! routine thermcell_down en cours de developpement'
+      IF (debut) PRINT*, 'WARNING !!! routine thermcell_down en cours de developpement'
       entrdn = fact_thermals_down * detr0
       detrdn = fact_thermals_down * entr0
@@ -632,5 +632,5 @@
       DO  ll=1,nlay
         DO ig=1,ngrid
-          if (iso_eau.gt.0) THEN
+          IF (iso_eau.gt.0) THEN
               CALL iso_verif_egalite(xtpo(iso_eau,ig,ll), &
             p_o(ig,ll),'thermcell_main 594')
@@ -638,5 +638,5 @@
             pdoadj(ig,ll),'thermcell_main 596')
           endif
-          if (iso_HDO.gt.0) THEN
+          IF (iso_HDO.gt.0) THEN
               CALL iso_verif_aberrant_encadre(xtpo(iso_hdo,ig,ll) &
              /p_o(ig,ll),'thermcell_main 610')
@@ -654,5 +654,5 @@
 
       !IM 090508
-      if (dvdq == 0) THEN
+      IF (dvdq == 0) THEN
         ! Calcul du transport de V tenant compte d'echange par gradient
         ! de pression horizontal avec l'environnement
@@ -681,5 +681,5 @@
     enddo
 
-    if (prt_level>=1) PRINT*, '14 OK convect8'
+    IF (prt_level>=1) PRINT*, '14 OK convect8'
     !------------------------------------------------------------------
     !   Calculs de diagnostiques pour les sorties
@@ -687,6 +687,6 @@
     !calcul de fraca pour les sorties
 
-    if (sorties) THEN
-      if (prt_level>=1) PRINT*, '14a OK convect8'
+    IF (sorties) THEN
+      IF (prt_level>=1) PRINT*, '14a OK convect8'
       ! calcul du niveau de condensation
       ! initialisation
@@ -704,6 +704,6 @@
       do k = 1, nlay - 1
         do ig = 1, ngrid
-          if ((pcon(ig)<=pplay(ig, k))  &
-                  .and.(pcon(ig)>pplay(ig, k + 1))) THEN
+          IF ((pcon(ig)<=pplay(ig, k))  &
+                  .AND.(pcon(ig)>pplay(ig, k + 1))) THEN
             zcon2(ig) = zlay(ig, k) - (pcon(ig) - pplay(ig, k)) / (RG * rho(ig, k)) / 100.
           endif
@@ -713,5 +713,5 @@
       ierr = 0
       do ig = 1, ngrid
-        if (pcon(ig)<=pplay(ig, nlay)) THEN
+        IF (pcon(ig)<=pplay(ig, nlay)) THEN
           zcon2(ig) = zlay(ig, nlay) - (pcon(ig) - pplay(ig, nlay)) / (RG * rho(ig, nlay)) / 100.
           ierr = 1
@@ -723,8 +723,8 @@
       !      endif
 
-      if (prt_level>=1) PRINT*, '14b OK convect8'
+      IF (prt_level>=1) PRINT*, '14b OK convect8'
       do k = nlay, 1, -1
         do ig = 1, ngrid
-          if (zqla(ig, k)>1e-10) THEN
+          IF (zqla(ig, k)>1e-10) THEN
             nivcon(ig) = k
             zcon(ig) = zlev(ig, k)
@@ -732,5 +732,5 @@
         enddo
       enddo
-      if (prt_level>=1) PRINT*, '14c OK convect8'
+      IF (prt_level>=1) PRINT*, '14c OK convect8'
       !calcul des moments
       !initialisation
@@ -744,6 +744,6 @@
         enddo
       enddo
-      if (prt_level>=1) PRINT*, '14d OK convect8'
-      if (prt_level>=10)WRITE(lunout, *)                                &
+      IF (prt_level>=1) PRINT*, '14d OK convect8'
+      IF (prt_level>=10)WRITE(lunout, *)                                &
               'WARNING thermcell_main wth2=0. si zw2 > 1.e-10'
       do l = 1, nlay
@@ -775,5 +775,5 @@
 
       !calcul du ratqscdiff
-      if (prt_level>=1) PRINT*, '14e OK convect8'
+      IF (prt_level>=1) PRINT*, '14e OK convect8'
       var = 0.
       vardiff = 0.
@@ -782,5 +782,5 @@
       do l = 1, nlay
         do ig = 1, ngrid
-          if (l<=lalim(ig)) THEN
+          IF (l<=lalim(ig)) THEN
             var = var + alim_star(ig, l) * zqta(ig, l) * 1000.
           endif
@@ -788,9 +788,9 @@
       enddo
 
-      if (prt_level>=1) PRINT*, '14f OK convect8'
+      IF (prt_level>=1) PRINT*, '14f OK convect8'
 
       do l = 1, nlay
         do ig = 1, ngrid
-          if (l<=lalim(ig)) THEN
+          IF (l<=lalim(ig)) THEN
             zf = fraca(ig, l)
             zf2 = zf / (1. - zf)
@@ -800,5 +800,5 @@
       enddo
 
-      if (prt_level>=1) PRINT*, '14g OK convect8'
+      IF (prt_level>=1) PRINT*, '14g OK convect8'
       do l = 1, nlay
         do ig = 1, ngrid
@@ -808,5 +808,5 @@
     endif
 
-    if (prt_level>=1) PRINT*, 'thermcell_main FIN  OK'
+    IF (prt_level>=1) PRINT*, 'thermcell_main FIN  OK'
 
     !PRINT*,'thermcell_main fin'
@@ -823,14 +823,14 @@
     IMPLICIT NONE
 
-    integer i, k, ngrid, nlay
-    real, intent(in), dimension(ngrid, nlay) :: pplay, ztv, p_o, ztva, zqla
-    real, intent(in), dimension(ngrid, nlay) :: f_star, zw2
-    integer, intent(in), dimension(ngrid) :: long
-    real seuil
+    INTEGER i, k, ngrid, nlay
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay) :: pplay, ztv, p_o, ztva, zqla
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay) :: f_star, zw2
+    INTEGER, INTENT(IN), DIMENSION(ngrid) :: long
+    REAL seuil
     character*21 comment
 
     seuil = 0.25
 
-    if (prt_level>=1) THEN
+    IF (prt_level>=1) THEN
       PRINT*, 'WARNING !!! TEST ', comment
     endif
@@ -840,5 +840,5 @@
     do i = 1, ngrid
       !IMtemp           if (pplay(i,long(i)).lt.seuil*pplev(i,1)) THEN
-      if (prt_level>=10) THEN
+      IF (prt_level>=10) THEN
         PRINT*, 'WARNING ', comment, ' au point ', i, ' K= ', long(i)
         PRINT*, '  K  P(MB)  THV(K)     Qenv(g/kg)THVA        QLA(g/kg)   F*        W2'
@@ -874,25 +874,25 @@
     !=======================================================================
 
-    integer ngrid, nlay
-
-    real, intent(in) :: ptimestep
-    real, intent(in), dimension(ngrid, nlay + 1) :: fm0, pplev
-    real, intent(in), dimension(ngrid, nlay) :: entr0
-    real, intent(in) :: rg
-    real, intent(out), dimension(ngrid, nlay) :: therm_tke_max
-
-    real detr0(ngrid, nlay)
-    real masse0(ngrid, nlay)
-    real masse(ngrid, nlay), fm(ngrid, nlay + 1)
-    real entr(ngrid, nlay)
-    real q(ngrid, nlay)
-    integer lev_out                           ! niveau pour les print
-
-    real qa(ngrid, nlay), detr(ngrid, nlay), wqd(ngrid, nlay + 1)
-    integer ig, k
+    INTEGER ngrid, nlay
+
+    REAL, INTENT(IN) :: ptimestep
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay + 1) :: fm0, pplev
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay) :: entr0
+    REAL, INTENT(IN) :: rg
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: therm_tke_max
+
+    REAL detr0(ngrid, nlay)
+    REAL masse0(ngrid, nlay)
+    REAL masse(ngrid, nlay), fm(ngrid, nlay + 1)
+    REAL entr(ngrid, nlay)
+    REAL q(ngrid, nlay)
+    INTEGER lev_out                           ! niveau pour les print
+
+    REAL qa(ngrid, nlay), detr(ngrid, nlay), wqd(ngrid, nlay + 1)
+    INTEGER ig, k
 
     lev_out = 0
 
-    if (prt_level>=1) PRINT*, 'Q2 THERMCEL_DQ 0'
+    IF (prt_level>=1) PRINT*, 'Q2 THERMCEL_DQ 0'
 
     !   calcul du detrainement
@@ -923,8 +923,8 @@
     !!!
 
-    if (1==1) THEN
+    IF (1==1) THEN
       do k = 2, nlay
         do ig = 1, ngrid
-          if ((fm(ig, k + 1) + detr(ig, k)) * ptimestep>  &
+          IF ((fm(ig, k + 1) + detr(ig, k)) * ptimestep>  &
                   1.e-5 * masse(ig, k)) THEN
             qa(ig, k) = (fm(ig, k) * qa(ig, k - 1) + entr(ig, k) * q(ig, k))  &
@@ -933,8 +933,8 @@
             qa(ig, k) = q(ig, k)
           endif
-          if (qa(ig, k)<0.) THEN
+          IF (qa(ig, k)<0.) THEN
             !               PRINT*,'qa<0!!!'
           endif
-          if (q(ig, k)<0.) THEN
+          IF (q(ig, k)<0.) THEN
             !               PRINT*,'q<0!!!'
           endif
@@ -947,5 +947,5 @@
         do ig = 1, ngrid
           wqd(ig, k) = fm(ig, k) * q(ig, k)
-          if (wqd(ig, k)<0.) THEN
+          IF (wqd(ig, k)<0.) THEN
             !               PRINT*,'wqd<0!!!'
           endif
